/**
 * 
 */
package org.gcube.accounting.datamodel.usagerecords;

import java.util.Set;

import org.gcube.documentstore.exception.InvalidValueException;
import org.gcube.testutility.ScopedTest;
import org.gcube.testutility.TestUsageRecord;
import org.junit.Assert;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Luca Frosini (ISTI - CNR) http://www.lucafrosini.com/
 *
 */
public class ServiceUsageRecordScopedTest extends ScopedTest {

	private static Logger logger = LoggerFactory.getLogger(ServiceUsageRecordScopedTest.class);
	
	@Test
	public void testRequiredFieldsScoped() throws InvalidValueException{
		ServiceUsageRecord usageRecord = TestUsageRecord.createTestServiceUsageRecord();
		
		Set<String> expectedRequiredFields = ServiceUsageRecordTest.getExpectedRequiredFields();
		logger.debug("Expected Required Fields : {}", expectedRequiredFields);
		
		Set<String> gotRequiredFields = usageRecord.getRequiredFields();
		logger.debug("Got Required Fields : {}", gotRequiredFields);
		
		Assert.assertTrue(expectedRequiredFields.containsAll(gotRequiredFields));
		Assert.assertTrue(gotRequiredFields.containsAll(expectedRequiredFields));
		
		usageRecord.validate();
		logger.debug("{}", usageRecord);
	}
	
}
